/**************************************************************************/
/*              COPYRIGHT Carnegie Mellon University 2023                 */
/* Do not post this file or any derivative on a public site or repository */
/**************************************************************************/
/*
 * Interface for stacks of type c0_value, specifically
 *
 * 15-122 Principles of Imperative Computation */

#include <stdbool.h>
#include "c0vm.h"

#ifndef VALSTACK_H
#define VALSTACK_H

// typedef ______* c0v_stack_t;
typedef struct c0v_stack_header *c0v_stack_t;

bool c0v_stack_empty(c0v_stack_t S)
  /*@requires S != NULL; @*/ ;

c0v_stack_t c0v_stack_new()
  /*@ensures \result != NULL; @*/ ;

void c0v_push(c0v_stack_t S, c0_value x)
  /*@requires S != NULL; @*/ ;

c0_value c0v_pop(c0v_stack_t S)
  /*@requires S != NULL; @*/ ;

size_t c0v_stack_size(c0v_stack_t S)
  /*@requires S != NULL; */ ;

void c0v_stack_print(c0v_stack_t S)
  /*@requires S != NULL; */ ;

void c0v_stack_free(c0v_stack_t S) /* Does not free elements */
  /*@requires S != NULL; @*/ ;

#endif
